import React from 'react';
import './propcounter.css';
import JSONKey from './jsonkey';
import SimpleJSONKey from './jsonkeysimple';

export default class PropChangeCounter extends React.PureComponent {
  constructor(props) {
    super(props)
    this.title = props.title;
    this.counts = {};
    this.constant = props.constant;
    for (let key of Object.keys(props)) {
      this.counts[key] = 0;
    }
  }
  componentWillReceiveProps(nextProps) {
    const keys = Array.from(new Set(Object.keys(nextProps).concat(Object.keys(this.props))))
    for (let key of keys) 
    {
      if (this.props[key] !== nextProps[key]) 
      {
        this.counts[key] = (this.counts[key] || 0) + 1
        if( key === "onChange" )
        {
          let callback = this.props[key];
          callback(this.constant + "==>" + this.counts[key]);
        }
      }
    }
  }
  render() {
    return (
      <div>
        <h3>prop change counts</h3>
          <ul>
            <li>xxx</li>
            <li>yyy</li>
            <JSONKey objects={this.counts}/>
          </ul>
      </div>
    )
  }
}
